/* L -> ascii ϊe[u */
/*  ߂lȂΕϊsv  */

#define	NA	0xff

#ifdef USE_EUC
char	puncttbl[128] = {
	NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA,
	NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA,
/* 0x2120- punctuation */
	NA, NA, NA, NA, ',','.',NA,':',';','?','!', NA, NA,'\'','`',NA,
	'^','~','_',NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, '/',
	NA, NA, NA, '|',NA, NA,'`','\'','\"','\"','(',')',NA, NA, '[',']',
	'{','}',NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, '+','-',NA, NA,

	NA, NA, '=',NA, '<','>',NA, NA, NA, NA, NA, NA, NA,'\'','\"',NA,
	'\\','$',NA, NA, '%','#','&','*','@',NA, NA, NA, NA, NA, NA, NA
};

/* p -> ascii ϊe[u */
/*  ߂lȂΕϊsv  */

char	alnumtbl[128] = {
	NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA,
	NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA,
	NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA,

/* 0x2330- number */
	'0','1','2','3','4','5','6','7','8','9',NA, NA, NA, NA, NA, NA,

/* 0x2340- alphabet(upper) */
	NA, 'A','B','C','D','E','F','G','H','I','J','K','L','M','N','O',
	'P','Q','R','S','T','U','V','W','X','Y','Z',NA, NA, NA, NA, NA,

/* 0x2360- alphabet(lower) */
	NA, 'a','b','c','d','e','f','g','h','i','j','k','l','m','n','o',
	'p','q','r','s','t','u','v','w','x','y','z',NA, NA, NA, NA, NA
};
#else
char	puncttbl[256] = {
	NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA,
	NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA,
	NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA,
	NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA,

	NA, NA, NA, ',','.',NA,':',';','?','!', NA, NA,'\'','`',NA,'^',
	'~','_',NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, '/',NA,
	NA, NA, '|',NA, NA,'`','\'','\"','\"','(',')',NA, NA, '[',']','{',
	'}',NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, '+','-',NA, NA, NA,

	NA, '=',NA, '<','>',NA, NA, NA, NA, NA, NA, NA,'\'','\"',NA,'\\',
	'$',NA, NA, '%','#','&','*','@',NA, NA, NA, NA, NA, NA, NA, NA,
	NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA,
	NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA,

	NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA,
	NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA,
	NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA,
	NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA
};

char	alnumtbl[256] = {
	NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA,
	NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA,
	NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA,
	NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA,

/* 0x824f- number */
	NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA,'0',
	'1','2','3','4','5','6','7','8','9',NA, NA, NA, NA, NA, NA, NA,

/* 0x8260- alphabet(upper) */
	'A','B','C','D','E','F','G','H','I','J','K','L','M','N','O','P',
	'Q','R','S','T','U','V','W','X','Y','Z',NA, NA, NA, NA, NA, NA,

/* 0x8281- alphabet(lower) */
	NA, 'a','b','c','d','e','f','g','h','i','j','k','l','m','n','o',
	'p','q','r','s','t','u','v','w','x','y','z',NA, NA, NA, NA, NA,

	NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA,
	NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA,
	NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA,

	NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA,
	NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA,
	NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA
};
#endif

/*
 e[u

    ߂l     :GXP[v镶
            0(AP):At@xbg(isascii)
           -1(SJ):VtgJIS1oCg(iskanji)
           -2(OT):ȊO
 */

#define	AP	0
#define	SJ	-1
#define	OT	-2

char	symboltbl[256] = {
	OT, OT, OT, OT, OT, OT, OT, OT,' ', OT,'\n',OT, OT,'\n',OT, OT,
	OT ,OT, OT, OT, OT, OT, OT, OT, OT, OT, OT, OT, OT, OT, OT, OT,
/* putctuation */
	' ',OT, OT, OT,'$','%', OT, OT, OT, OT, OT, OT, OT, OT, OT, OT,
/* number */
	OT, OT, OT, OT, OT, OT, OT, OT, OT, OT, OT, OT, OT, OT, OT, OT,
/* alphabet(upper) */
	OT, AP, AP, AP, AP, AP, AP, AP, AP, AP, AP, AP, AP, AP, AP, AP,
	AP, AP, AP, AP, AP, AP, AP, AP, AP, AP, AP, OT,'\\',OT,'^','_',
/* alphabet(lower) */
	OT, AP, AP, AP, AP, AP, AP, AP, AP, AP, AP, AP, AP, AP, AP, AP,
	AP, AP, AP, AP, AP, AP, AP, AP, AP, AP, AP,'{', OT,'}', OT, OT,
/* high code in shift jis */
	SJ, SJ, SJ, SJ, SJ, SJ, SJ, SJ, SJ, SJ, SJ, SJ, SJ, SJ, SJ, SJ,
	SJ, SJ, SJ, SJ, SJ, SJ, SJ, SJ, SJ, SJ, SJ, SJ, SJ, SJ, SJ, SJ,
/* kana code in shift jis */
	OT, OT, OT, OT, OT, OT, OT, OT, OT, OT, OT, OT, OT, OT, OT, OT,
	OT, OT, OT, OT, OT, OT, OT, OT, OT, OT, OT, OT, OT, OT, OT, OT,

	OT, OT, OT, OT, OT, OT, OT, OT, OT, OT, OT, OT, OT, OT, OT, OT,
	OT, OT, OT, OT, OT, OT, OT, OT, OT, OT, OT, OT, OT, OT, OT, OT,
/* high code in shift jis */
	SJ, SJ, SJ, SJ, SJ, SJ, SJ, SJ, SJ, SJ, SJ, SJ, SJ, SJ, SJ, SJ,
	SJ, SJ, SJ, SJ, SJ, SJ, SJ, SJ, SJ, SJ, SJ, SJ, SJ, OT, OT, OT
};
