#include	<stdio.h>
#include	<string.h>

#include	"hwrap.h"

void	macro_init(hwrap_state*);
static void	putspace(int);
void	prespc(hwrap_state*, STR*);
void	putemptyline(hwrap_state*);
static void	addspc(hwrap_state*, int);
void	print(hwrap_state*);


/* ܂Ԃ󋵂̏ */
void
macro_init(s)
hwrap_state	*s;
{
	s->colum = s->stdcolum;
	s->inasc = 0;
	s->outasc = 0;
	s->outct = 0;
	s->outesc = 0;
	s->backskip = FALSE;
	if (s->post < 0) {
		s->post = 1;	/* 1Ԃ炳֑ */
	}
	s->buf_bak = s->buf_p;
}

/* 󔒂}BTAB֎~ */
static void
putspace(j)
int	j;
{
	while (--j >= 0)	fputc(' ', stdout);
}

/* sɋ󔒂o */
void
prespc(s, str)
hwrap_state	*s;
STR	*str;
{
	if (!s->margin || str[0] == LF)	return;
	putspace(s->margin);
}

/* so */
void
putemptyline(s)
hwrap_state	*s;
{
	if (s->boxon) {		/* g */
		putspace (s->margin + s->indcol);
		fputc('|', stdout);
		putspace(s->stdcolum + 1);
		fputc('|', stdout);
	}
	fputc('\n', stdout);
}

/* sɋ󔒂t */
static void
addspc(s, spc)
hwrap_state	*s;
int	spc;
{
	int	i;

	if (spc) {
		s->outct += spc;
		for (i = s->outct; i >= 0; i--) {
			s->outbuf[i + spc] = s->outbuf[i];
		}
		for (i = 0; i < spc; i++) {
			s->outbuf[i] = ' ';
		}
	}
}

/* so */
void
print(s)
hwrap_state	*s;
{
	int	i;
	int	code, code_sub;
								/* Ԃ炳֑ */
	static STR	bol[] = "ABCDEFGHIJKLMNOPQRSTUVWXYZ[\]^_`abcdfhjlnprtvxz@BDFHb";
/*	static STR	bol[] = "ABECDb@BDFH僃`[IHcdjnv`^";*/
	static STR	bol1[] = ",.:;?!^~_-/\\|)]}";

	if (!s->outct) {			/* s͖ */
		macro_init(s);
		return;
	}

	/* Ԃ炳֑`FbN */
	code = bgetc(1, s);			/* ̕ */
	code_sub = bgetc(1, s);		/* 1oCgǂ */

	if (code >= 0 && iskanji(code) && code_sub >= 0) {
		for (i = 0; bol[i]; i += 2) {
								/* ֑Ɣr */
			if (code == bol[i] && code_sub == bol[i + 1]) {
				if (s->post <= 0 && s->outct - s->outesc + 2 >= s->colum) {
								/* Ԃ炳֑Ȃ */
					s->buf_p = s->buf_bak;
					macro_init(s);
					s->colum -= (s->colum_bak +=2);
					return;
				}
				if (s->post == 1) {
								/* 1Ԃ炳֑ -> Ȃ */
					s->post = -1;
				}
				s->colum += 2;
				code = bgetc(1, s);		/* Ɏ̕ */
				bgetc(-3, s);
				if (code == LF)	s->colum++;
				return;
			}
		}
	} else if (code >= 0) {
		for (i = 0; bol1[i]; i++) {
								/* 1byte֑Ɣr */
			if (code == bol1[i]) {
				if (s->post <= 0 && s->outct - s->outesc + 1 >= s->colum) {
								/* Ԃ炳֑Ȃ */
					s->buf_p = s->buf_bak;
					macro_init(s);
					s->colum -= (s->colum_bak += 1);
					return;
				}
				if (s->post == 1) {
								/* 1Ԃ炳֑ -> Ȃ */
					s->post = -1;
				}
				s->colum += 1;
				bgetc(-2, s);
				if (code_sub == LF)	s->colum++;
				return;
			}
		}
	}
	bgetc(-2, s);

	/* Ōオ󔒂Ȃ폜 */
	if (s->outbuf[s->outct - 1] == ' ') {
		s->outbuf[--s->outct] = '\0';
	}

	/* ŌオESCV[PXȂ΍폜 */
	if (s->outct == s->escon + 1) {
		int	esclen = strlen(s->esc);
		s->outct -= esclen;
		s->outbuf[s->outct] = '\0';
		s->escon -= esclen;
		s->buf_p -= esclen;
	}

	switch (s->align) {
	case 1:		/* CENTER */
		addspc(s, (s->stdcolum - (s->outct - s->outesc)) / 2);
		break;
	case -1:	/* RIGHT */
		addspc(s, s->stdcolum - (s->outct - s->outesc));
	}

	if (s->indcol) {			/* ] */
		i = s->indcol - s->iconlen;
		putspace (i);
	}

	if (s->iconlen) {			/* }[N */
		s->iconlen = 0;
		fputs(s->icon, stdout);
	}

	if (s->boxon == 1)	fputc('|', stdout);
	fputs(s->outbuf, stdout);	/* {̏o */
	if (s->boxon == 1) {
		for (i = s->outct - s->outesc; i < s->stdcolum + 1; i++) {
			fputc(' ', stdout);
		}
		fputc('|', stdout);
	} else if (s->boxon == 2) {
		s->boxon = 1;
	}
	fputc('\n', stdout);

	macro_init(s);			/* ܂Ԃԏ */
	s->colum_bak = 0;
}
