#include	<stdio.h>
#include	<string.h>

#include	"hwrap.h"

void	wrap(hwrap_state*);
void	hwrap(hwrap_state*);


/* ܂Ԃ */
void
wrap(s)
hwrap_state	*s;
{
	int i;
	int	code, code_sub;
								/* ǂo֑ */
	static STR	eol[] = "egikmoqsuwy";
/*	static STR	eol[] = "uim";*/
	static STR	eol1[] = "([{";

	/* [N */
	while ((code = bgetc(1, s)) >= 0) {
		if (iskanji(code)) {	/* 2oCg */
			if ((code_sub = bgetc(1, s)) < 0)	break;
			if (s->outct - s->outesc + 2 >= s->colum) {
				/* ǂo֑`FbN */
				for (i = 0; eol[i]; i += 2) {
					if (code == eol[i]
							&& code_sub == eol[i + 1]) {
						/* ܂łŐ܂Ԃ */
						s->outbuf[s->outct] = '\0';
						bgetc(-2,s);
						return;
					}
				}
			}
#ifdef USE_EUC
			if (code == 0x8e) {
				/* pJ^Ji */
				s->inasc += 2;
				s->outasc += 2;
				s->outesc++;
#else
			if ((code == 0x80) || (code >= 0xF0)) {
				/* 2oCgp,1/4pR[h */
				s->inasc += 2;
				if (!s->fasc){
					s->outasc++;
					s->outbuf[s->outct++] = code;
				} else {
					s->outasc += 2;
					s->outesc++;
				}
#endif
			} else {	/* ʂ̑Sp */
				s->backskip = TRUE;
				s->inasc = 0;
				s->outasc = 0;
				s->outbuf[s->outct++] = code;
			}
			s->outbuf[s->outct++] = code_sub;

		} else {	/* 1oCg */
			if (s->outct - s->outesc + 1 >= s->colum) {
				/* 1byteǂo֑`FbN */
				for (i = 0; eol1[i]; i++) {
					if (code == eol1[i]) {
						/* ܂łŐ܂Ԃ */
						s->outbuf[s->outct] = '\0';
						bgetc(-1,s);
						return;
					}
				}
			}
			if (!code || code == LF) {	/* iI */
				break;
			} else if (code == ESCC) {
				i = 1;
				do {
					if ((code = bgetc(1, s)) < 0) {
						bgetc(-1, s);
						break;
					}
					s->esc[i++] = code;
					if (i > 5) {
						fputs("ΉESCV[PXł\n", stderr);
						s->outbuf[s->outct] = '\0';
						return;
					}
				} while ((code != 'm') && (code != 'M'));
				if (s->useesc) {
					s->esc[i] = '\0';
					strcpy(s->outbuf + s->outct, s->esc);
					s->outct += i;
					s->outesc += i;
					s->backskip = TRUE;
					s->inasc = 0;
					s->outasc = 0;
					if (!strcmp(s->esc, "\x1b[m") || !strcmp (s->esc, "\x1b[M")) {
						s->escon = -2;
					} else {
						s->escon = s->outct - s->outesc;
					}
				}
				continue;
			}

			s->outbuf[s->outct++] = code;
			s->outasc++;
			s->inasc++;
			if (s->spcdiv && code == ' ') {
				s->backskip = TRUE;
				s->outasc = 0;
				s->inasc = 0;
			}
		}

		if (s->outct - s->outesc >= s->colum) {
			/* ܂ԂKv */
			code = bgetc(1, s);
			bgetc(-1, s);
			if (code >= 0 && code == LF){
				s->colum++;
				continue;
			}

			if (s->backskip) {	/* 1߂ */
				bgetc(-s->inasc, s);
				s->outct -= s->outasc;
			}
			break;
		}
	}
	s->outbuf[s->outct] = '\0';
}

/* C */
void
hwrap(s)
hwrap_state	*s;
{
	int	c;
	STR		*p, str[BUFSIZE];
	FLAG	local_esc = FALSE;
	FLAG	sjis1 = 0, sjis1_bak;
	FLAG	linetype = 1; /* 0:normal 1:macro, -1:lf */

	if (!bopen(s, BUFSIZE * 4))	return;
	while (fgets(str, BUFSIZE, s->fp)) {
		p = str;
		if (sjis1 < 0) {			/* Os̑ */
			sjis1 = 0;
			bputc(*p++, s);
		} else if (*p == LF || *p == CR) {
			if (linetype < 0){		/* As */
				bflush(s, &linetype);
			} else if (s->buf_p) {	/* iI */
				bflush(s, &linetype);
				s->usepb = FALSE;
			}
			linetype = -1;			/* Ȃ */
			continue;
		} else {
									/* s󔒍폜 */
			while (*p == ' ' || *p == '\t')	p++;
			if (p[0] == MACRO_SYMBOL
					&& (!symboltbl[p[1]])) {
									/* }N */
				if (s->buf_p) {
					bflush(s, &linetype);
					s->usepb = FALSE;
				}
				linetype = 1;
			} else if (linetype) {	/* Vi */
				if (s->nextline) {
					s->nextline &= 0xfe;
				} else {
					bputc(' ', s);	/* indent */
					bputc(' ', s);
				}
				linetype = 0;
			}
		}

		/* Lu */
		while (*p) {
			sjis1_bak = sjis1;
			if (s->fasc) {
#ifdef USE_EUC
				if (*p == 0xa3
						&& (c = alnumtbl[*(p + 1) & 0x7f]) >= 0) {
#else
				if (*p == 0x82
						&& (c = alnumtbl[*(p + 1)]) >= 0) {
#endif
					bputc(c, s);	/* Spp */
					sjis1 = 0;
					p += 2;
					continue;
#ifdef USE_EUC
				} else if (*p == 0xa1
						&& (c = puncttbl[*(p + 1) & 0x7f]) >= 0) {
#else
				} else if (*p == 0x81
						&& (c = puncttbl[*(p + 1)]) >= 0) {
#endif
					bputc(c, s);	/* SpL */
					sjis1 = 0;
					p += 2;
					continue;
				}
			}
			sjis1 = iskanji(*p);
			if (sjis1) {			/* Sp */
				bputc(*p++, s);
				if (!*p) {
					sjis1 = -1;
					break;
				}
			} else {
				switch (*p) {
				case EM_CHR:		/*  */
					bputs(local_esc?ESCEND:ESCEM, s);
					local_esc = ~local_esc;
					p++;
					continue;
				case UL_CHR:		/* A_[C */
					bputs(local_esc?ESCEND:ESCUL, s);
					local_esc = ~local_esc;
					p++;
					continue;
				case IT_CHR:		/* ] */
					bputs(local_esc?ESCEND:ESCIT, s);
					local_esc = ~local_esc;
					p++;
					continue;
				case '\t':			/* TAB͔p󔒂 */
					bputc(' ', s);
					p++;
					continue;
				case MACRO_SYMBOL:	/* GXP[v */
					if (symboltbl[p[1]] > 0) {
						bputc(symboltbl[p[1]], s);
						if (p[1] == CR) {
							p += 3;
						} else {
							p += 2;
						}
						continue;
					}
					break;
				case 0x1a:			/* EOFCR͖ */
				case CR:
					sjis1 = sjis1_bak;
					p++;
					continue;
				case COMMENT_SYMBOL:	/* Rg */
					while (*++p);
					continue;
				case '{':
				case '}':
					bputc('\t', s);
					p++;
					continue;
				case LF:				/* s */
					if (!linetype ) {	/* ʏsȂ疳 */
						if (!sjis1_bak) {
									/* OpȂ󔒂 */
							bputc(' ', s);
						}
					} else {
						bflush(s, &linetype);
					}
					p++;
					continue;
				default:
					break;
				}
			}
			bputc(*p++, s);
		}
	}
	bflush(s, &linetype);
	bclose(s);	/* I */
}

