#include	<stdio.h>
#include	<stdlib.h>


#include	"hwrap.h"


static void	init(hwrap_state*);
static void	help(void);


/* ԕϐ̏ */
void
init(s)
hwrap_state	*s;
{
	int	i;

	s->buf_p = 0;
	s->buf_bak = 0;
	s->outct = 0;
	s->outesc = 0;

	s->outasc = 0;
	s->inasc = 0;
	s->stdcolum = DEFAULT_COLUMNS;
	s->colum_bak = 0;
	s->indcol = 0;
	s->margin = 0;
	s->section = 0;
	s->fp = stdin;

	s->escon = -2;
	s->useesc = TRUE;
	s->fasc = FALSE;
	s->spcdiv = FALSE;
	s->post = 2;
	s->boxon = FALSE;
	s->post_bak = FALSE;

	s->nextline = 0;
	s->iconlen = 0;
	s->it_level = -1;		/* ITEMIZE x */
	s->en_level = -1;		/* ENUMERATE x */
	for (i = 0; i < 5; i++) {
		s->listtype[i] = 0;	/*  1:itemize 2:enumerate */
	}
	s->listlevel = 0;		/* (ITEMIZE + ENUMERATE)x( < 4) */
	s->q_level = 0;			/* x( < 4) */
	s->quotetype = 0;		/*  = 0(nothing):1(quote):2(drow):3(rquote) */
	s->rq_level = 0;		/* rq_level x */
	s->align = 0;			/*  */

	s->usepb = FALSE;
	s->backskip = FALSE;
	s->esc[0] = ESCC;
}

/* wvbZ[WWG[o͂ɕ\ */
static void
help()
{
	fputs("Hyper Word RAP tool v3.63  CopyRight Kazuhisa Minato 1996,97,98\n", stderr);
	fputs("               revision 2  Copyleft  Rick            1999\n", stderr);
	fputs("    hwrap [options] [<filename>]\n", stderr);
	fputs("       -a[num] Spp̐ݒ\n", stderr);
	fputs("         0     Ȃ (default)\n", stderr);
	fputs("         1     ł邾ASCIIɕϊ\n", stderr);
	fputs("       -e      ESCV[PXgpȂ\n", stderr);
	fputs("       -k[num] ֑̐ݒ\n", stderr );
	fputs("         0     ǂô֑\n", stderr);
	fputs("         1     Sp1Ԃ炳֑\n", stderr);
	fputs("         2     łԂ炳֑ (default)\n", stderr);
	fputs("       -l[num] 1snumŐ܂Ԃidefault 70j\n", stderr);
	fputs("       -m[num] ŜnumE֊񂹂 (default 0)\n", stderr);
	fputs("       -s      pP̌̋󔒂܂Ԃ̖ڈƂ\n", stderr);
	exit(1);
}

void
main(argc, argv)
int	argc;
STR	**argv;
{
	hwrap_state	st;			/* hwrap ԊǗ\ */
	STR	*input_file = NULL;	/* ̓t@C */

	init(&st);
	while (--argc > 0) {
		++argv;
		if (**argv == '-') {
			switch (*(*argv + 1) & 0xdf) {
			case 'A':	st.fasc = *(*argv + 2) - '0';	break;
			case 'E':	st.useesc = FALSE;				break;
			case 'K':	st.post = atoi(*argv + 2);		break;
			case 'L':	st.stdcolum = atoi(*argv + 2);	break;
			case 'M':	st.margin = atoi(*argv + 2);	break;
			case 'S':	st.spcdiv = TRUE;				break;
			default:
				help();
			}
		} else if (!input_file) {
			input_file = *argv;
		} else
			help();
	}

	st.colum = st.stdcolum;		/* ܂Ԃ */

	/* ՎΉ */
	if (input_file) {
		st.fp = fopen(input_file, "rb");
		if (!st.fp) {
			fputs("̓t@C܂\n", stderr);
			exit(1);
		}
	}

	hwrap(&st);
	if (st.fp != stdin)	fclose(st.fp);
}
